'''
CopyRight: http://ZopeChina.com Ϻ׿Ϣι˾
Email: panjy@zopechina.ods.org

˵һUTF8ZCIndexsplitter. 

todo:
1. CJKΧж
3. ǿģѯ֧
4. 쳣Ĳutf8ᵼԽ
'''

from Products.ZCTextIndex.PipelineFactory import element_factory
from Globals import InitializeClass, DTMLFile, package_home

# ʹԴļŶ֣site.py
# ȡַ
import ConfigParser, os, sys

def _get_error():
    type, value = sys.exc_info()[:2]
    return str(type), str(value)

config = ConfigParser.ConfigParser()

filename=os.path.join(INSTANCE_HOME,package_home(globals() ),'CJKSplitter.ini')
try: 
    config.readfp(open(filename))
except: 
    # no file found
    print("No config file found, this is probably fine [%s, %s]" % _get_error())


splitters_charset = config.get('default', 'charset')
splitters_count = config.getint('default', 'count')

utfCJKSplitters = []
for i in range(1, splitters_count + 1):
    splitter = config.get('splitters', 's%d'%i)
    utf8splitter = unicode(splitter, splitters_charset).encode('utf8')
    utfCJKSplitters.append( utf8splitter )

print utfCJKSplitters
# utfCJKSplitters = [''.encode('utf8'), ''.encode('utf8'), ''.encode('utf8'), ''.encode('utf8'),]
utfSplitters = [' ', '\t', '\n', '\r', '\v',' \f',  
		    '!', '"', '#', '$', '%', '&', "'", '(', ')', 
		    '*', '+', ',', '-', '.', '/', ':', ';', '<', 
		    '=', '>', '?', '@', '[', '\\', ']', '^', '_', 
		    '`', '{', '|', '}', '~']

class CJKSplitter:
    
    def _getWords(self, str, isGlob=1):
	i = 0 # index of the string
	strLength = len(str)
	words = []
	isCJKWordLast = -1 # һǷCJKַ, -1 ʼ; 0 ; 1 
        isCJKWordCur = -1 # ǰµַǷCJKַ, -1 ʼ; 0 ; 1 
        word = ""
	while (i < strLength) :
	    # 1 õһUTF8ַ
	    ch = str[i]
            
	    isLastBigram = (isCJKWordLast == 1) and  (isCJKWordCur == 1) # ǰ洦һĴ
            isCJKWordLast = isCJKWordCur; # ¾ɽ
	    # 1.1 UTF8, жַмֽ
	    if (ord(ch) >= 0xE0): # byte, , 趼CJKַ, ʵbug! 
		ch = str[i] + str[i+1] + str[i+2]
		i = i + 3
		
		if isCJKWordLast == 1: # жǰCJK
		    if ch not in utfCJKSplitters: # CJK 
                        word += ch # ֳɴ
                        words += [word] # 
                        word = ch # Ԫָ㷨
                    else:
                        isCJKWordCur = -1
                        words += [word] # ˴bugܳظĵ
		elif isCJKWordLast == 0: # ǰ
                    if ch not in utfCJKSplitters: # CJK 
                        words += [word]
                        word = ch
                        isCJKWordCur = 1
                    else :
                        words += [word]
                        isCJKWordCur = -1
		else : # ǰʼ
                    if ch not in utfCJKSplitters: # CJK
                        word = ch
                        isCJKWordCur = 1
	    else : # 
		if (ord(ch) >= 0xC0): # byte 
		    ch = str[i] + str[i+1]
		    i = i + 2
		else :
		    i = i + 1
	    	    	
		if isCJKWordLast == 0 : # ǰҲ
		    if ch not in utfSplitters:
			word += ch
		    else :
			words += [word]
			isCJKWordCur = -1 
		elif isCJKWordLast == 1 : # ǰCJK
		    if not isLastBigram: # ֺ˫ظĵ
                        words += [word] 
                    elif ch not in utfSplitters:
			word = ch
			isCJKWordCur = 0
		    else :
			isCJKWordCur = -1
		else : # ǰʼ
		    if ch not in utfSplitters:
			word = ch
			isCJKWordCur = 0
		    else :
			isCJKWordCur = -1
	if isCJKWordCur == 0: # һӢ
            words += [word]
        elif isCJKWordCur == 1 and isCJKWordLast != 1: # ϳɵֵĺ
            words += [word]
	return words
    
    def process(self, lst):
        result = []
        for s in lst:
            result += self._getWords(s)
        return result

    def processGlob(self, lst):
        result = []
        for s in lst:
            result += self._getWords(s, 1)
        return result

element_factory.registerFactory('Word Splitter', 'CJK splitter', CJKSplitter)

# ڲ
'''
sp = CJKSplitter()
a = sp.process(["ǣthis is a test. Σһʵˡɵ".encode('utf8')])
for t in a:
    print unicode(t, 'utf8')
'''
